var closy = {

	initialized: false,

	init: function() {
		if (!this.initialized) {
			var tabMenu = document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");
			if (tabMenu) {
		  	var menuitemsep = document.createElement("menuseparator");
				var menuitemclose = document.createElement("menuitem");
				menuitemclose.setAttribute("label", document.getElementById("bundle_closy").getString("closy-closeblanktabs.label"));
				menuitemclose.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-closeblanktabs.tooltiptext"));
				menuitemclose.setAttribute("oncommand", "closy.closeBlankTabs();");
				var menuitemdupe = document.createElement("menuitem");
				menuitemdupe.setAttribute("label", document.getElementById("bundle_closy").getString("closy-closeduplicatetabs.label"));
				menuitemdupe.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-closeduplicatetabs.tooltiptext"));
				menuitemdupe.setAttribute("oncommand", "closy.closeDuplicateTabs();");
				var insertPos = tabMenu.lastChild.previousSibling;
				tabMenu.insertBefore(menuitemdupe, insertPos);
				tabMenu.insertBefore(menuitemclose, menuitemdupe);
				tabMenu.insertBefore(menuitemsep, menuitemclose);
				this.initialized = true;
			}
		}
	},

	closeBlankTabs: function() {
		var tabs = gBrowser.mTabContainer.childNodes;
		for (var i = tabs.length-1; i >= 0; i--) {
			if (gBrowser.getBrowserAtIndex(i).currentURI.spec == "about:blank") {
				if (i && gBrowser.selectedTab == tabs[i]) {
					gBrowser.selectedTab = tabs[i-1];
				}
				gBrowser.removeTab(tabs[i]);
			}
		}
	},

	closeDuplicateTabs: function() {
		var urlclose = new Array();
		var urlhash = new Object();
		var tabs = gBrowser.mTabContainer.childNodes;
		for (var i = tabs.length-1; i >= 0; i--) {
			var uri = gBrowser.getBrowserAtIndex(i).currentURI.spec;
			if (urlhash[uri]) {
				urlclose[urlclose.length] = i;
			} else {
				urlhash[uri] = true;
			}
		}
		for (var i = 0, max = urlclose.length; i < max; i++) {
			gBrowser.removeTab(tabs[urlclose[i]]);
		}
	},

};

var tabMenu = document.getAnonymousElementByAttribute(getBrowser(), "anonid", "tabContextMenu");
if (tabMenu) {
	tabMenu.addEventListener("popupshowing", function(e) {closy.init(e)}, false);
}
